//focus on sdl

//play channel demo

//fosdl11_1.cpp
//28JUN2002
//ernest pazera

//requires static linkage to:  
//sdl.lib, sdlmain.lib, sdl_mixer.lib

//requires dynamic linkage to: 
//sdl.dll, sdl_mixer.dll

//include SDL stuff
#include "sdl/sdl.h"
#include "sdl_mixer/sdl_mixer.h"

//include ability to exit program
#include <stdlib.h>

//screen dimensions
const int SCREEN_WIDTH=640;
const int SCREEN_HEIGHT=480;

//display surface
SDL_Surface* g_pDisplaySurface = NULL;

//event structure
SDL_Event g_Event;

//sound chunk
Mix_Chunk* g_pChunk[2];

//main function
int main(int argc, char* argv[])
{
	//initialize SDL
	if (SDL_Init(SDL_INIT_VIDEO)==-1)
	{
		//error initializing SDL
		
		//report the error
		fprintf(stderr,"Could not initialize SDL!\n");
		
		//end the program
		exit(1);
	}
	else
	{
		//SDL initialized
		
		//report success
		fprintf(stdout,"SDL initialized properly!\n");
		
		//set up to uninitialize SDL at exit
		atexit(SDL_Quit);
	}
	
	//create windowed environment
	g_pDisplaySurface = SDL_SetVideoMode(SCREEN_WIDTH,SCREEN_HEIGHT,0,SDL_ANYFORMAT);
	
	//error check
	if (g_pDisplaySurface == NULL)
	{
		//report error
		fprintf(stderr,"Could not set up display surface!\n");
		
		//exit the program
		exit(1);
	}
	
	//start up sdl_mixer
	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,1,4096);
	
	//load the chunks
	g_pChunk[0]=Mix_LoadWAV("Song.wav");
	g_pChunk[1]=Mix_LoadWAV("succeed.wav");
	
	//allocate channels
	Mix_AllocateChannels(2);
	
	//play the chunk
	Mix_PlayChannel(0,g_pChunk[0],-1);
	
	//repeat forever
	for(;;)
	{
		//wait for an event
		if(SDL_PollEvent(&g_Event)==0)
		{
			//update the screen
			SDL_UpdateRect(g_pDisplaySurface,0,0,0,0);
		}
		else
		{
			//event occurred, check for quit
			if(g_Event.type==SDL_QUIT) break;
			
			//check for keypress
			if(g_Event.type==SDL_KEYDOWN)
			{
				//play channel 1
				Mix_PlayChannel(1,g_pChunk[1],0);
			}
		}
	}
	
	//deallocate channels
	Mix_AllocateChannels(0);
	
	//free the chunks
	Mix_FreeChunk(g_pChunk[0]);
	Mix_FreeChunk(g_pChunk[1]);
	
	//close sdl_mixer
	Mix_CloseAudio();
	
	//normal termination
	fprintf(stdout,"Terminating normally.\n");
	
	//return 0
	return(0);
}